using System;
using System.Collections.Generic;
using System.Text;

namespace MofuMofu.Boosting
{
    /// <summary>
    /// AdaBoost̎NX
    /// </summary>
    public class AdaBoost : Boosting
    {
        /// <summary>
        /// ͎
        /// </summary>
        private TrainExampleList examples;
        public TrainExampleList Examples
        {
            get { return this.examples; }
        }
        /// <summary>
        /// ㎯ʊ
        /// </summary>
        private ClassifierList classifiers;
        public ClassifierList Classifiers
        {
            get { return this.classifiers; }
        }
        /// <summary>
        /// ͎ɑ΂d
        /// </summary>
        private double[] weights;
        public double[] Weights
        {
            get { return this.weights; }
        }
        /// <summary>
        /// ʊ
        /// </summary>
        private StrongClassifier strongClassifier;
        public StrongClassifier StrongClassifier
        {
            get { return this.strongClassifier; }
            set { this.strongClassifier = value; }
        }


        public AdaBoost(TrainExampleList examples, ClassifierList classifiers)
        {
            this.examples = examples;
            this.classifiers = classifiers;
            this.strongClassifier = new StrongClassifier();

            //d݂
            InitializeWeight();
        }

        /// <summary>
        /// d݂̏
        /// </summary>
        private void InitializeWeight()
        {
            //PositiveᐔNegativeᐔJEg
	        int positiveCount = 0;
	        int negativeCount = 0;
	        for(int i=0; i<this.examples.Count; i++)
	        {
                if(examples[i].Label == 0)
		        {
			        negativeCount++;
		        }
		        else
		        {
			        positiveCount++;
		        }
            }

            //d݂
            this.weights = new double[examples.Count];
	        for(int i=0; i<this.weights.Length; i++)
	        {
                if(examples[i].Label == 0)
		        {
                    this.weights[i] = 1.0 / (2.0*negativeCount);
		        }
		        else
		        {
                    this.weights[i] = 1.0 / (2.0*positiveCount);
		        }
	        }
        }

        /// <summary>
        /// d݂̐K
        /// </summary>
        private void NormalizeWeight()
        {
	        double total = 0.0;
	        for(int w=0; w<this.weights.Length; w++)
	        {
                total += this.weights[w];
	        }

	        for(int w=0; w<this.weights.Length; w++)
	        {
                this.weights[w] = this.weights[w] / total;
	        }
        }

        #region Boosting o
        /// <summary>
        /// ̎㎯ʊI
        /// </summary>
        /// <returns></returns>
        public BoostingResult Next()
        {
            //㎯ʊ̌뎯ʗ
            double[] errors = new double[this.classifiers.Count];

            //d݂𐳋K
            NormalizeWeight();

            //eɑ΂Ae㎯ʊ̌뎯ʗvZ
            for (int e = 0; e < this.examples.Count; e++)
            {
                //
                TrainExample te = examples[e];

                for (int c = 0; c < this.classifiers.Count; c++)
                {
                    if (classifiers[c].Test(te.Example) != te.Label)
                    {
                        errors[c] += this.weights[e];
                    }
                }
            }

            //ŏ̌뎯ʗ㎯ʊI
	        int lowestIndex = 0;
	        double lowestError = errors[lowestIndex];
	        for(int e = 0; e<errors.Length; e++)
	        {
		        if(lowestError > errors[e])
		        {
			        lowestError = errors[e];
			        lowestIndex = e;
		        }
	        }

	        //d݂XV
	        double beta = lowestError / (1.0 - lowestError);
            Classifier lowestClassifier = this.classifiers[lowestIndex];
	        for(int e=0; e<this.examples.Count; e++)
	        {
		        double b = beta;
                TrainExample te = this.examples[e];

                if(lowestClassifier.Test(te.Example) != te.Label)
		        {
			        //ʂȂꍇ
			        b = 1.0;
		        }

                this.weights[e] = this.weights[e] * b;
	        }

            //㎯ʊ̐MxvZ
            double conf = Math.Log(1.0 / beta);

            //ʊɒǉ
            ClassifierConf selectedClassifier = new ClassifierConf(lowestClassifier, conf);
            this.strongClassifier.Classifiers.Add(selectedClassifier);

            //AdaBoost̎s
            return new AdaBoostResult(strongClassifier, selectedClassifier);
        }

        #endregion
    }
}
