﻿using System;
using System.Collections.Generic;
using System.Text;

using MofuMofu.Boosting;

namespace MofuMofu
{
    class Program
    {
        /// <summary>
        /// AdaBoostのテスト
        /// </summary>
        /// <param name="args"></param>
        static void Main(string[] args)
        {
            //学習事例
            TrainExampleList examples = new TrainExampleList();
            examples.Add(new TrainExample(new SimpleExample(1, 0, 1, 1, 1), 0));
            examples.Add(new TrainExample(new SimpleExample(0, 0, 1, 0, 1), 1));
            examples.Add(new TrainExample(new SimpleExample(1, 0, 0, 1, 0), 1));
            examples.Add(new TrainExample(new SimpleExample(0, 1, 0, 1, 1), 1));

            //弱識別器
            ClassifierList classifiers = new ClassifierList();
            classifiers.Add(new SimpleClassifier(0, -1, -1, -1, -1));
            classifiers.Add(new SimpleClassifier(1, -1, -1, -1, -1));
            classifiers.Add(new SimpleClassifier(-1, 0, -1, -1, -1));
            classifiers.Add(new SimpleClassifier(-1, 1, -1, -1, -1));
            classifiers.Add(new SimpleClassifier(-1, -1, 0, -1, -1));
            classifiers.Add(new SimpleClassifier(-1, -1, 1, -1, -1));
            classifiers.Add(new SimpleClassifier(-1, -1, -1, 0, -1));
            classifiers.Add(new SimpleClassifier(-1, -1, -1, 1, -1));
            classifiers.Add(new SimpleClassifier(-1, -1, -1, -1, 0));
            classifiers.Add(new SimpleClassifier(-1, -1, -1, -1, 1));

            //AdaBoost初期化
            AdaBoost adaBoost = new AdaBoost(examples, classifiers);

            //AdaBoostを実行
            for (int t = 0; t < 10; t++)
            {
                AdaBoostResult result = (AdaBoostResult)adaBoost.Next();
                ClassifierConf selectedClassifier = result.SelectedClassifier;

                //選択された弱識別器を表示
                System.Console.WriteLine("{0}, {1}, {2}", t, selectedClassifier.Classifier.ToString(), selectedClassifier.Conf);
            }

            System.Console.WriteLine("テスト");

            //得られた強識別器をテスト
            StrongClassifier strongClassifier = adaBoost.StrongClassifier;
            for (int i = 0; i < examples.Count; i++)
            {
                int a = strongClassifier.Test(examples[i].Example);
                string s = a == examples[i].Label ? "正解" : "不正解";

                System.Console.WriteLine("{0}, {1}, {2}", s, a, examples[i].Label);
            }
        }
    }
}
